﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Public oSQL As SQL
	
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	
	
	'If You Are NOT Planning To Use DataBase then everythig here can be removed .... !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	
	
	'  DataBase     ##############################################################################
	
	'@ Debug  Delete database 
	'File.Delete(File.DirInternal,  "book_data.db")
	'Return
	
	'Sleep(200)
	
	'Check for Database existance ...
	If Not(File.Exists(File.DirInternal,  "book_data.db")) Then
		File.Copy(File.DirAssets, "book_data.db", File.DirInternal, "book_data.db")
		Log("No Database ...   Copying database from assets !")
	End If
		
	'initialize the database ... do not create new
	oSQL.Initialize (File.DirInternal,"book_data.db",False)
	
	'@ Debug To Completely Delete a  Table  ...
	'oSQL.ExecNonQuery("DROP TABLE IF EXISTS Library")
	'Return
	
	'@Debug Rebuild Table
	'oSQL.ExecNonQuery("CREATE TABLE Library (Id INTEGER PRIMARY KEY, Author TEXT, BookTitle TEXT)")
	'Return
	'Sleep(200)

	' Data File     ##############################################################################
	'Check for Data File existance ...
	If Not(File.Exists(File.DirInternal,  "data.txt")) Then
		File.Copy(File.DirAssets, "data.txt", File.DirInternal, "data.txt")
		Log("No Database ...   Copying data file from assets !")		'
	End If
	
	
	'You only want to do this once ...   Then start updating the DB instead
	'ProcessDataToDB
	
	'Log Contents of DataBase
	'LogDataBaseEntries
	
	'@Debug   Copy file to external dir .... Runtime permissions need to be included or change Manifest to Target = 22
	'File.Copy(File.Dirinternal, "book_data.db", File.DirDefaultExternal, "book_data.db")
	
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub ProcessDataToDB
	
	'write datafile to Public List
	 Dim DataList As List = File.ReadList(File.DirInternal, "data.txt")
	 
	 DataList.RemoveAt(DataList.Size -1) 	'remove <!end>
	 DataList.RemoveAt(0)								'remove <!start>
	
	For Each s As String In DataList
		Log("***  " & s)
	Next
	
	Dim Author As String 
	For Each item As String In DataList     'Start at 2nd entry , finish at second last entry ( Disregard  &
		
		If item.SubString2(0, 3) = "###" Then
			Author = item.SubString(3)		'refresh author
		Else
			'must be non ### Author Line ... write previous Author & new Item
			oSQL.ExecNonQuery2("INSERT INTO Library VALUES (NULL,?, ?)" , Array As String(Author, item))
		End If
	Next
	
End Sub

Sub LogDataBaseEntries
	
	Dim res As ResultSet = oSQL.ExecQuery("SELECT * FROM Library")
		
	Do While res.NextRow
		Log(res.GetString("Author") & "    "  & res.GetString("BookTitle"))
	Loop
	
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
